SystemOrganization addCategory: #BoBreakout!

ImageMorph subclass: #BoBreakout
	instanceVariableNames: 'activeScreen screenCatalog'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BoBreakout'!

!BoBreakout commentStamp: 'PS 1/19/2014 15:36:54.145' prior: 0!
I am the root of the Swa05Breakout game!

!BoBreakout class methodsFor: 'constants' stamp: 'PS 1/28/2014 09:21:38.871'!
creditsScreen

	^ #credits! !

!BoBreakout class methodsFor: 'parts bin' stamp: 'PL 1/30/2014 22:51:38.815'!
descriptionForPartsBin

	^ self
		partName: 'BoBreakout'
		categories: #('SWA14')
		documentation: 'Breakout by group 05'! !

!BoBreakout class methodsFor: 'constants' stamp: 'PS 1/28/2014 09:21:23.874'!
gameOverScreen

	^ #gameOver! !

!BoBreakout class methodsFor: 'constants' stamp: 'PS 1/28/2014 09:21:07.892'!
gameScreen

	^ #game! !

!BoBreakout class methodsFor: 'constants' stamp: 'PS 1/28/2014 09:21:30.542'!
gameWonScreen

	^ #gameWon! !

!BoBreakout class methodsFor: 'constants' stamp: 'PS 1/28/2014 09:21:15.891'!
menuScreen

	^ #menu! !

!BoBreakout methodsFor: 'accessing' stamp: 'PS 1/27/2014 18:13:39.516'!
activeScreen

	^ activeScreen! !

!BoBreakout methodsFor: 'accessing' stamp: 'PS 1/27/2014 18:13:39.589'!
activeScreen: anObject

	activeScreen := anObject! !

!BoBreakout methodsFor: 'submorphs-add/remove' stamp: 'mb 1/30/2014 15:13'!
delete

	BoSoundPlayer instance stopLoop.
	super delete! !

!BoBreakout methodsFor: 'event handling' stamp: 'PS 1/2/2014 13:55:11.226'!
handlesMouseOver: anEvent

	^ true! !

!BoBreakout methodsFor: 'initialization' stamp: 'mb 1/30/2014 15:14'!
initialize

	super initialize.
	BoTextureProvider recreateInstance.
	BoSoundPlayer recreateInstance.
	self 
		setNewImageFrom: 
			(BoTextureProvider instance textureWithSymbol: #background);
		loadComponent: #menu! !

!BoBreakout methodsFor: 'parts bin' stamp: 'PS 1/2/2014 12:02:45.262'!
initializeToStandAlone 
	
	self initialize! !

!BoBreakout methodsFor: 'component loading' stamp: 'BM 1/28/2014 12:52'!
loadComponent: aSymbol

	self activeScreen ifNotNil: [ self removeMorph: self activeScreen ].
	self
		activeScreen: (self screenCatalog at: aSymbol) value;
		addMorph: self activeScreen.
	self screenCatalog at: aSymbol put: self activeScreen.
	self activeScreen onLoad.
	ActiveHand newKeyboardFocus: self mouseFocusTarget! !

!BoBreakout methodsFor: 'event handling' stamp: 'PS 1/27/2014 20:52:16.862'!
mouseEnter: anEvent

	ActiveHand newKeyboardFocus: self mouseFocusTarget! !

!BoBreakout methodsFor: 'event handling' stamp: 'PS 1/27/2014 20:51:54.902'!
mouseFocusTarget 

	^ self activeScreen mouseFocusTarget! !

!BoBreakout methodsFor: 'event handling' stamp: 'PL 1/11/2014 15:13:10.017'!
mouseLeave: anEvent

	ActiveHand newKeyboardFocus: nil! !

!BoBreakout methodsFor: 'accessing' stamp: 'mb 1/30/2014 15:12'!
screenCatalog

	^ screenCatalog ifNil: [ screenCatalog := IdentityDictionary newFrom: {
		self class creditsScreen -> [ BoCreditsScreen newOn: self ].
		self class menuScreen -> [ BoMenuScreen newOn: self ].
		self class gameScreen -> [ BoGameScreen newOn: self ].
		self class gameWonScreen -> [ BoGameWonScreen newOn: self ].
		self class gameOverScreen -> [ BoGameOverScreen newOn: self ] } ]! !

!BoBreakout methodsFor: 'accessing' stamp: 'PS 1/28/2014 09:17:00.168'!
screenCatalog: anObject

	screenCatalog := anObject! !

ImageMorph subclass: #BoCollidableMorph
	instanceVariableNames: 'collisionHandler referenceDotProduct cachedDotProducts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BoBreakout'!

!BoCollidableMorph commentStamp: 'PS 1/19/2014 15:37:26.762' prior: 0!
I am a Morph MovingMorphs can collide with!

BoCollidableMorph subclass: #BoBlock
	instanceVariableNames: 'remainingLifes blocks destroySpeed itemTypes itemDropProbability items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BoBreakout'!

!BoBlock commentStamp: 'PS 1/19/2014 15:37:54.238' prior: 0!
I am a Block which can be destroyed in Breakout!

!BoBlock class methodsFor: 'constants' stamp: 'PS 11/23/2013 16:40:35.57'!
destroySpeed

	^ 0.5! !

!BoBlock class methodsFor: 'constants' stamp: 'PS 11/23/2013 17:04:09.418'!
lifes

	^ 1! !

!BoBlock class methodsFor: 'instance creation' stamp: 'mb 1/13/2014 21:44'!
newOn: aBlockManager with: aCollisionHandler and: anItemManager
	
	^ self new
		blocks: aBlockManager;
		collisionHandler: aCollisionHandler;
		items: anItemManager! !

!BoBlock class methodsFor: 'constants' stamp: 'PS 11/21/2013 15:10:01.174'!
scope

	^ 80 @ 30! !

!BoBlock methodsFor: 'layout' stamp: 'mb 1/30/2014 23:48'!
applyBubbleBlockStyle

	| imageName |
	imageName := 'bubbleblock'.
	
	self loadBackgroundWithName: imageName! !

!BoBlock methodsFor: 'layout' stamp: 'PL 1/31/2014 15:38:21.441'!
applyDefaultStyle

	| imageName |	
	imageName := 'block'.
	
	self loadBackgroundWithName: imageName ! !

!BoBlock methodsFor: 'layout' stamp: 'mb 1/30/2014 23:48'!
applyStrongBlockStyle

	| imageName |
	imageName := 'strongblock'.
	
	self loadBackgroundWithName: imageName ! !

!BoBlock methodsFor: 'layout' stamp: 'PS 1/19/2014 15:11:18.02'!
applyStyle
	
	self remainingLifes > 1
		ifTrue: [ self applyStrongBlockStyle ]
		ifFalse: [ self applyDefaultStyle ].
	self collisionHandler isBubbleBlock
		ifTrue: [ self applyBubbleBlockStyle ]! !

!BoBlock methodsFor: 'accessing' stamp: 'PL 1/11/2014 12:58:07.68'!
blocks

	^ blocks! !

!BoBlock methodsFor: 'accessing' stamp: 'PL 1/11/2014 12:58:07.727'!
blocks: anObject

	blocks := anObject! !

!BoBlock methodsFor: 'accessing' stamp: 'PS 1/19/2014 15:11:05.095'!
collisionHandler: anObject

	super collisionHandler: anObject.
	self applyStyle! !

!BoBlock methodsFor: 'accessing' stamp: 'PS 1/12/2014 17:37:27.531'!
decreaseLifesBy: aNumber

	self remainingLifes: self remainingLifes - aNumber.
	self remainingLifes isZero ifTrue: [ self remove ]! !

!BoBlock methodsFor: 'accessing' stamp: 'PS 12/8/2013 13:35:34.542'!
destroySpeed

	^ destroySpeed ifNil: [ destroySpeed := self class destroySpeed ]! !

!BoBlock methodsFor: 'accessing' stamp: 'PS 12/8/2013 13:34:42'!
destroySpeed: anObject

	destroySpeed := anObject! !

!BoBlock methodsFor: 'item dropping' stamp: 'PS 1/16/2014 19:07:16.08'!
handleItemDrop

	self willDropAnItem ifTrue: [
		self items dropItem: (self itemTypes atRandom) at: (self itemDropPoint) ]! !

!BoBlock methodsFor: 'item dropping' stamp: 'SO 1/30/2014 21:35:59.709'!
itemDropPoint

	^ self bottomCenter - ((self width / 2) @ 0)! !

!BoBlock methodsFor: 'accessing' stamp: 'SO 1/13/2014 12:24:13.802'!
itemDropProbability

	^ itemDropProbability! !

!BoBlock methodsFor: 'accessing' stamp: 'SO 1/13/2014 12:24:13.809'!
itemDropProbability: anObject

	itemDropProbability := anObject! !

!BoBlock methodsFor: 'accessing' stamp: 'SO 1/11/2014 17:25:32.293'!
itemTypes

	^ itemTypes! !

!BoBlock methodsFor: 'accessing' stamp: 'SO 1/11/2014 17:19:51.061'!
itemTypes: anObject

	itemTypes := anObject! !

!BoBlock methodsFor: 'accessing' stamp: 'PS 1/13/2014 13:30:36.637'!
items

	^ items! !

!BoBlock methodsFor: 'accessing' stamp: 'PS 1/13/2014 13:30:36.664'!
items: anObject

	items := anObject! !

!BoBlock methodsFor: 'accessing' stamp: 'PS 12/11/2013 15:43:43.598'!
remainingLifes

	^ remainingLifes ifNil: [ remainingLifes := self class lifes ]! !

!BoBlock methodsFor: 'accessing' stamp: 'PS 1/9/2014 10:46:10.534'!
remainingLifes: anObject

	remainingLifes := anObject max: 0.
	self applyStyle! !

!BoBlock methodsFor: 'removing' stamp: 'PL 1/11/2014 12:58:26.917'!
remove
	
	self blocks remove: self! !

!BoBlock methodsFor: 'item dropping' stamp: 'SO 1/30/2014 21:36:36.252'!
willDropAnItem

	^ (self itemDropProbability isZero not) and: 
		[ (1 / self itemDropProbability) atRandom = 1 ]! !

!BoCollidableMorph methodsFor: 'collision' stamp: 'SO 1/30/2014 21:32:56.557'!
addLineFrom: startPoint to: endPoint ifValidInto: aCollection
	
	((self facingToDirection: startPoint) and: [ self facingToDirection: endPoint ]) ifTrue: [ 
		aCollection add: 
			(self calculateBorderLineSegmentBetween: startPoint and: endPoint) ]
	
	! !

!BoCollidableMorph methodsFor: 'accessing' stamp: 'mb 1/22/2014 17:28'!
cachedDotProducts

	^ cachedDotProducts! !

!BoCollidableMorph methodsFor: 'accessing' stamp: 'mb 1/22/2014 17:28'!
cachedDotProducts: anObject

	cachedDotProducts := anObject! !

!BoCollidableMorph methodsFor: 'collision' stamp: 'mb 1/30/2014 15:07'!
calculateBorderLineSegmentBetween: aPoint and: anotherPoint

	| lineSegment |
	
	lineSegment := BoLineSegment new.
	lineSegment point: aPoint.
	lineSegment vector: anotherPoint - aPoint.
	
	^ lineSegment! !

!BoCollidableMorph methodsFor: 'collision' stamp: 'SO 1/30/2014 21:33:36.061'!
calculateBorderLineSegmentsFor: aDirection

	| lineSegments |
	
	lineSegments := OrderedCollection new.
	
	self preCalculateDotProductsFor: aDirection.	
	self addLineFrom: self topLeft to: self topRight 
		ifValidInto: lineSegments.		
	self addLineFrom: self topRight to: self bottomRight 
		ifValidInto: lineSegments.		
	self addLineFrom: self bottomRight to: self bottomLeft 
		ifValidInto: lineSegments.		
	self addLineFrom: self bottomLeft to: self topLeft 
		ifValidInto: lineSegments.
		
	^ lineSegments! !

!BoCollidableMorph methodsFor: 'accessing' stamp: 'mb 1/13/2014 21:51'!
collisionHandler

	^ collisionHandler! !

!BoCollidableMorph methodsFor: 'accessing' stamp: 'tfel 5/9/2014 14:43'!
collisionHandler
	<layer: #bubbleBlocks>
	^ BoBubbleBlockCollisionHandler new! !

!BoCollidableMorph methodsFor: 'accessing' stamp: 'mb 1/13/2014 21:52'!
collisionHandler: anObject

	collisionHandler := anObject! !

!BoCollidableMorph methodsFor: 'collision' stamp: 'mb 1/22/2014 18:03'!
facingToDirection: aPoint
	
	^ ((self cachedDotProducts at: aPoint) < self referenceDotProduct)! !

!BoCollidableMorph methodsFor: 'collision' stamp: 'mb 1/13/2014 21:53'!
handleCollisionWith: aMovingObject at: aPoint
	
	self collisionHandler handleCollisionWith: aMovingObject and: self at: aPoint! !

!BoCollidableMorph methodsFor: 'initialization' stamp: 'mb 1/30/2014 15:14'!
loadBackgroundWithName: aString

	self setNewImageFrom:
		(BoTextureProvider instance textureWithSymbol: (aString asSymbol))! !

!BoCollidableMorph methodsFor: 'collision' stamp: 'SO 1/30/2014 21:33:53.06'!
preCalculateDotProductsFor: aDirection

	| dict |
	
	dict := Dictionary new.
	
	dict at: (self topLeft) 
		put: (aDirection dotProduct: (self topLeft - (self center))).
	dict at: (self topRight) 
		put: (aDirection dotProduct: (self topRight - (self center))).
	dict at: (self bottomRight) 
		put: (aDirection dotProduct: (self bottomRight - (self center))).
	dict at: (self bottomLeft) 
		put: (aDirection dotProduct: (self bottomLeft - (self center))).
	self referenceDotProduct: (dict max).
	self cachedDotProducts: dict
	! !

!BoCollidableMorph methodsFor: 'accessing' stamp: 'mb 1/22/2014 11:49'!
referenceDotProduct

	^ referenceDotProduct! !

!BoCollidableMorph methodsFor: 'accessing' stamp: 'mb 1/22/2014 11:49'!
referenceDotProduct: anObject

	referenceDotProduct := anObject! !

BoCollidableMorph subclass: #BoGame
	instanceVariableNames: 'container paddle blocks balls currentLevel levelDisplay lifes items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BoBreakout'!

!BoGame commentStamp: 'PS 1/19/2014 15:38:48.898' prior: 0!
I am the part of Breakout which observes level flow and I represent the gameField borders!

!BoGame class methodsFor: 'constants' stamp: 'PS 1/6/2014 13:30:41.524'!
maxLifes

	^ 6! !

!BoGame class methodsFor: 'instance creation' stamp: 'PS 1/27/2014 19:59:39.514'!
newOn: aMorph

	^ self new
		container: aMorph;
		position: aMorph position;
		setup;
		yourself! !

!BoGame methodsFor: 'accessing' stamp: 'PS 1/2/2014 11:36:21.626'!
balls

	^ balls! !

!BoGame methodsFor: 'accessing' stamp: 'PS 1/2/2014 11:36:21.659'!
balls: anObject

	balls := anObject! !

!BoGame methodsFor: 'accessing' stamp: 'PS 1/2/2014 11:36:21.57'!
blocks

	^ blocks! !

!BoGame methodsFor: 'accessing' stamp: 'PS 1/2/2014 11:36:21.593'!
blocks: anObject

	blocks := anObject! !

!BoGame methodsFor: 'collision' stamp: 'mb 1/22/2014 00:03'!
calculateBorderLineSegmentsFor: aDirection

	^ super calculateBorderLineSegmentsFor: (aDirection negated)! !

!BoGame methodsFor: 'accessing' stamp: 'PS 1/27/2014 19:56:48.214'!
container

	^ container! !

!BoGame methodsFor: 'accessing' stamp: 'PS 1/27/2014 19:56:48.271'!
container: anObject

	container := anObject! !

!BoGame methodsFor: 'accessing' stamp: 'PL 1/11/2014 17:13:07.13'!
currentLevel

	^ currentLevel! !

!BoGame methodsFor: 'accessing' stamp: 'BM 1/3/2014 17:23'!
currentLevel: anObject

	currentLevel := anObject! !

!BoGame methodsFor: 'level flow' stamp: 'mb 1/30/2014 14:09'!
finishLevel
	
	self currentLevel: self currentLevel + 1.
	(self currentLevel <= self numberOfLevels) 
		ifTrue: [ self loadCurrentLevel ]
		ifFalse: [ self gameWon ]! !

!BoGame methodsFor: 'level flow' stamp: 'mb 1/30/2014 15:13'!
gameOver

	BoSoundPlayer instance playSound: #gameOver.
	self lifes resetLifes.
	self 
		currentLevel: 1;
		loadCurrentLevel.
	self container loadComponent: #gameOver! !

!BoGame methodsFor: 'level flow' stamp: 'PS 1/28/2014 19:55:04.415'!
gameWon

	self lifes resetLifes.
	self 
		currentLevel: 1;
		loadCurrentLevel.
	self container loadComponent: #gameWon! !

!BoGame methodsFor: 'initialization' stamp: 'mb 1/30/2014 14:55'!
initialize
	
	super initialize.
	self
		currentLevel: 1;
		collisionHandler: BoGameCollisionHandler new;
		loadBackgroundWithName: 'background'! !

!BoGame methodsFor: 'initialization' stamp: 'mb 1/30/2014 15:08'!
initializeBalls
	
	self balls: (BoBallBasket newWith: self).
	self balls paddle: self paddle.
	self paddle balls: self balls! !

!BoGame methodsFor: 'initialization' stamp: 'mb 1/30/2014 15:08'!
initializeBlocks

	self blocks: (BoBlockGroup newWith: self).
	self blocks items: self items! !

!BoGame methodsFor: 'initialization' stamp: 'mb 1/30/2014 15:08'!
initializeItems

	self items: (BoItemDropper newWith: self).
	self balls items: self items! !

!BoGame methodsFor: 'initialization' stamp: 'mb 1/30/2014 14:11'!
initializeLevelDisplay

	self levelDisplay: StringMorph new.
	self levelDisplay 
		position: (self left + 4) @ (self top + 4);
		font: ((TextStyle default fontOfSize: 36) emphasized: 1).
	self addMorph: self levelDisplay! !

!BoGame methodsFor: 'initialization' stamp: 'mb 1/30/2014 15:08'!
initializeLifes

	self lifes: (BoLifeBar newWith: self).	
	self balls lifes: self lifes.
	self lifes resetLifes! !

!BoGame methodsFor: 'initialization' stamp: 'mb 1/30/2014 15:04'!
initializePaddle
	
	self paddle: (BoPaddle newOn: self).
	self addMorph: self paddle! !

!BoGame methodsFor: 'accessing' stamp: 'PL 1/11/2014 12:39:35.06'!
items

	^ items! !

!BoGame methodsFor: 'accessing' stamp: 'PL 1/11/2014 12:39:35.102'!
items: anObject

	items := anObject! !

!BoGame methodsFor: 'accessing' stamp: 'SO 1/9/2014 18:27:13.295'!
levelDisplay

	^ levelDisplay! !

!BoGame methodsFor: 'accessing' stamp: 'SO 1/9/2014 18:27:13.326'!
levelDisplay: anObject

	levelDisplay := anObject! !

!BoGame methodsFor: 'accessing' stamp: 'SO 1/4/2014 14:28:08.405'!
lifes

	^ lifes! !

!BoGame methodsFor: 'accessing' stamp: 'SO 1/4/2014 14:28:08.433'!
lifes: anObject

	lifes := anObject! !

!BoGame methodsFor: 'level loading' stamp: 'mb 1/30/2014 15:13'!
loadCurrentLevel
	
	BoSoundPlayer instance playSound: #levelLoaded.
	self paddle startOver.
	self blocks removeAll.
	self balls resetBalls.
	self items removeAll.
	self 
		parseLevel: self currentLevel;
		updateLevelDisplay.
	self lifes bringAllToFront! !

!BoGame methodsFor: 'level loading' stamp: 'PL 1/31/2014 15:26:39.244'!
loadLevelFile: aNumber

	| fileName defaultURI levelExtension |
	defaultURI := 'BoBreakout/levels/level'.
	levelExtension := '.lvl'.
	
	fileName := (FileDirectory uri: defaultURI, aNumber, levelExtension) fullName.
	^ FileStream fileNamed: fileName ! !

!BoGame methodsFor: 'level flow' stamp: 'PL 1/31/2014 16:01:45.967'!
numberOfLevels

	| levelCount  defaultURI extensionMask |
	defaultURI := 'BoBreakout/levels'.
	extensionMask := '*.lvl'.
	
	levelCount := 0.
	(FileDirectory uri: defaultURI) fileNames do: [ :entry |
		(extensionMask match: entry) ifTrue: [ 
			levelCount := levelCount + 1 ]].
	
	^ levelCount! !

!BoGame methodsFor: 'accessing' stamp: 'PS 1/2/2014 11:36:21.482'!
paddle

	^ paddle! !

!BoGame methodsFor: 'accessing' stamp: 'PS 1/2/2014 11:36:21.539'!
paddle: anObject

	paddle := anObject! !

!BoGame methodsFor: 'level loading' stamp: 'mb 1/30/2014 23:35'!
parseLevel: aNumber

	| stream posY |
	
	posY := self top.
	stream := self loadLevelFile: aNumber.
	[ stream atEnd ] whileFalse: [
		self parseRow: (stream upTo: Character cr) at: posY.
		posY := posY + BoBlock scope y ].
	
	stream close
	! !

!BoGame methodsFor: 'level loading' stamp: 'mb 1/30/2014 15:03'!
parseRow: aString at: aYCoordinate

	| point |	
		
	point := self left @ aYCoordinate.
	aString do: [ :char | 
		(self blocks isValidBlockTypeCharacter: char) 
			ifTrue: [ self blocks addBlockAt: point as: char ].
		((self blocks isValidBlockTypeCharacter: char) or: [char = Character space])
			ifTrue: [ point := (point x + BoBlock scope x) @ point y ]]! !

!BoGame methodsFor: 'initialization' stamp: 'PS 1/21/2014 08:50:31.212'!
setup

	self
		initializePaddle;
		initializeBalls;
		initializeItems;
		initializeBlocks;
		initializeLifes;
		initializeLevelDisplay;
		loadCurrentLevel! !

!BoGame methodsFor: 'level loading' stamp: 'PL 1/31/2014 15:41:44.719'!
updateLevelDisplay

	| levelString |	
	levelString := 'Level '.

	self levelDisplay 
		contents: levelString, self currentLevel;
		comeToFront! !

BoCollidableMorph subclass: #BoMovingMorph
	instanceVariableNames: 'realPosition speed direction game isFirstChecking objectOfCollision nextCollisionPoint nextCollisionDistance remainingStep moveLineSegments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BoBreakout'!

!BoMovingMorph commentStamp: 'PS 1/19/2014 15:39:09.035' prior: 0!
I am a Morph which moves over the GameField!

BoMovingMorph subclass: #BoBall
	instanceVariableNames: 'strength balls'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BoBreakout'!

!BoBall commentStamp: 'PS 1/19/2014 15:39:21.49' prior: 0!
I am the ball and can destroy blocks!

!BoBall class methodsFor: 'constants' stamp: 'BM 1/8/2014 12:18'!
maxSpeed

	^ 20! !

!BoBall class methodsFor: 'constants' stamp: 'tfel 5/9/2014 14:29'!
maxSpeed
	<layer: #speedyBalls>
	^ 40! !

!BoBall class methodsFor: 'constants' stamp: 'PS 1/9/2014 14:13:46.299'!
minReleaseAngle

	^ 30! !

!BoBall class methodsFor: 'constants' stamp: 'BM 1/8/2014 13:48'!
minSpeed

	^ 4! !

!BoBall class methodsFor: 'constants' stamp: 'tfel 5/9/2014 14:29'!
minSpeed
	<layer: #speedyBalls>
	^ 8! !

!BoBall class methodsFor: 'instance creation' stamp: 'PS 1/13/2014 20:25:40.716'!
newOn: aGame with: aBallBasket
	
	^ self new
		game: aGame;
		balls: aBallBasket! !

!BoBall class methodsFor: 'constants' stamp: 'BM 11/10/2013 19:58'!
scope

	^ 20 @ 20! !

!BoBall class methodsFor: 'constants' stamp: 'PS 11/23/2013 15:40:09.311'!
startSpeed

	^ 6! !

!BoBall class methodsFor: 'constants' stamp: 'PS 1/6/2014 15:53:17.304'!
strength

	^ 1! !

!BoBall class methodsFor: 'constants' stamp: 'tfel 5/9/2014 14:25'!
strength
	<layer: #strongBalls>
	^ 2! !

!BoBall methodsFor: 'effects' stamp: 'PS 12/11/2013 23:07:19.527'!
accelerateBy: aNumber
	
	self speed: self speed + aNumber! !

!BoBall methodsFor: 'accessing' stamp: 'PS 1/13/2014 20:23:55.096'!
balls

	^ balls! !

!BoBall methodsFor: 'accessing' stamp: 'PS 1/13/2014 20:23:55.155'!
balls: anObject

	balls := anObject! !

!BoBall methodsFor: 'collision' stamp: 'mb 1/30/2014 14:34'!
calculateAdaptiveMovePointWith: anAngle

	| radius simplifiedDirection |
	
	radius := self width / 2.
	simplifiedDirection := self calculateSimplifiedDirection.
	
	^ self center + ((simplifiedDirection x * radius * anAngle cos) @ 
		(simplifiedDirection y * radius * anAngle sin))! !

!BoBall methodsFor: 'collision' stamp: 'PL 1/31/2014 15:45:28.598'!
calculateAdaptiveMovePoints

	| angles |
	
	angles := { 
		0. 
		(( 1 / 4 ) * Float pi). 
		(( 1 / 2 ) * Float pi). 
		(( -3 / 8 ) * Float pi). 
		(( 7 / 8 ) * Float pi) }.
	
	^ angles collect: [ :each | self calculateAdaptiveMovePointWith: each ]! !

!BoBall methodsFor: 'collision' stamp: 'PL 1/31/2014 15:45:38.896'!
calculateMoveLineSegments

	| points |
	
	points := self calculateAdaptiveMovePoints.
	
	^ points collect: [ :each | self calculateMoveLineSegmentAt: each ]! !

!BoBall methodsFor: 'collision' stamp: 'mb 1/30/2014 14:35'!
calculateSimplifiedDirection

	| simplifiedDirection |
	
	simplifiedDirection := self direction sign.
	(simplifiedDirection x isZero) ifTrue: [ simplifiedDirection := ( 1 @ simplifiedDirection y) ].
	(simplifiedDirection y isZero) ifTrue: [ simplifiedDirection := ( simplifiedDirection x @ 1) ].
	
	^ simplifiedDirection! !

!BoBall methodsFor: 'positioning' stamp: 'PS 1/12/2014 17:23:39.074'!
centerAbove: aMorph

	self moveTo: aMorph topCenter - ((self width / 2) @ (self height + 1))! !

!BoBall methodsFor: 'collision' stamp: 'PL 1/4/2014 21:52:50.996'!
collidesWith

	^ #(game block paddle)! !

!BoBall methodsFor: 'movement' stamp: 'PL 1/6/2014 15:45:40.937'!
deflectBy: aVector

	self direction: self direction + aVector! !

!BoBall methodsFor: 'initialization' stamp: 'mb 1/30/2014 14:38'!
initialize

	| imageName |
	
	imageName := 'ball'.

	super initialize.
	self loadBackgroundWithName: imageName! !

!BoBall methodsFor: 'classification' stamp: 'PS 12/10/2013 14:32:13.095'!
isBall

	^ true! !

!BoBall methodsFor: 'classification' stamp: 'PS 12/11/2013 09:24:32.187'!
isCaptured

	^ self speed isZero! !

!BoBall methodsFor: 'movement' stamp: 'PS 12/11/2013 11:35:15.253'!
move

	self moveBy: self moveVector! !

!BoBall methodsFor: 'movement' stamp: 'PS 12/11/2013 09:35:06.865'!
moveTo: aPoint

	self position: aPoint! !

!BoBall methodsFor: 'movement' stamp: 'mb 1/30/2014 14:40'!
randomDirection

	| angle |
	
	angle := (60 atRandom + self class minReleaseAngle) degreesToRadians.
	self direction: (angle cos * #(1 -1) atRandom) @ (angle sin negated)! !

!BoBall methodsFor: 'movement' stamp: 'PS 12/11/2013 11:18:58.674'!
reflectBy: aVector

	self direction: self direction * aVector! !

!BoBall methodsFor: 'movement' stamp: 'PS 12/17/2013 09:36:43.086'!
releaseBall

	self speed: self class startSpeed ! !

!BoBall methodsFor: 'removing' stamp: 'PS 1/13/2014 20:24:47.786'!
remove

	self balls remove: self! !

!BoBall methodsFor: 'accessing' stamp: 'PS 1/9/2014 14:10:28.805'!
speed: anObject

	anObject isZero ifTrue: [ speed := anObject ]
		ifFalse: [ speed := (anObject min: self class maxSpeed) max: self class minSpeed ]! !

!BoBall methodsFor: 'initialization' stamp: 'PS 1/12/2014 17:21:33.876'!
startOverAbove: aMorph

	self 
		centerAbove: aMorph;
		speed: 0;
		randomDirection.
	aMorph hasBall: true! !

!BoBall methodsFor: 'accessing' stamp: 'tfel 5/9/2014 14:26'!
strength

	^ self class strength! !

BoMovingMorph subclass: #BoItem
	instanceVariableNames: 'items effectBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BoBreakout'!

!BoItem commentStamp: 'PS 1/19/2014 15:39:50.339' prior: 0!
I can give the player acces to special effects!

!BoItem class methodsFor: 'constants' stamp: 'PL 1/8/2014 11:40:49.308'!
itemSpeed

	^ 4! !

!BoItem class methodsFor: 'instance creation' stamp: 'PS 1/27/2014 22:57:22.89'!
newOn: aGame with: anItemManager and: aString perform: aBlock

	^ self new
		game: aGame;
		items: anItemManager;
		effectBlock: aBlock;
		loadBackgroundWithName: 'items', aString;
		yourself! !

!BoItem methodsFor: 'effects' stamp: 'mb 1/30/2014 15:13'!
applyEffect

	BoSoundPlayer instance playSound: #itemCollected.
	(self effectBlock) value! !

!BoItem methodsFor: 'collision' stamp: 'mb 1/30/2014 23:57'!
calculateMoveLineSegments

	| segmentContainer |
	
	segmentContainer := OrderedCollection new.
	
	segmentContainer add: (self calculateMoveLineSegmentAt: self bottomRight).
	segmentContainer add: (self calculateMoveLineSegmentAt: self bottomLeft).
	
	^ segmentContainer! !

!BoItem methodsFor: 'collision' stamp: 'PS 12/10/2013 14:42:49.199'!
collidesWith

	^ #(paddle game)! !

!BoItem methodsFor: 'accessing' stamp: 'PS 1/15/2014 22:36:23.502'!
effectBlock

	^ effectBlock! !

!BoItem methodsFor: 'accessing' stamp: 'PS 1/15/2014 22:36:23.561'!
effectBlock: anObject

	effectBlock := anObject! !

!BoItem methodsFor: 'initialization' stamp: 'PL 1/31/2014 15:46:22.003'!
initialize 

	| verticalDirection |	
	verticalDirection := 0 @ 1.

	super initialize.
	self 
		direction: verticalDirection;
		speed: self class itemSpeed! !

!BoItem methodsFor: 'classification' stamp: 'PS 12/10/2013 14:31:40.975'!
isItem

	^ true! !

!BoItem methodsFor: 'accessing' stamp: 'PS 1/12/2014 17:51:38.881'!
items

	^ items! !

!BoItem methodsFor: 'accessing' stamp: 'PS 1/12/2014 17:51:38.911'!
items: anObject

	items := anObject! !

!BoItem methodsFor: 'removing' stamp: 'PS 1/12/2014 17:51:44.817'!
remove

	self items remove: self! !

!BoMovingMorph methodsFor: 'geometry' stamp: 'PL 1/11/2014 11:29:04.33'!
bottom

	^ (self realPosition y + self height)! !

!BoMovingMorph methodsFor: 'geometry' stamp: 'SO 1/30/2014 21:37:13.65'!
bottom: aNumber

	super bottom: aNumber.
	self position: ((self realPosition x) @ (aNumber - self height))! !

!BoMovingMorph methodsFor: 'geometry' stamp: 'SO 1/30/2014 21:37:30.364'!
bottomLeft

	^ ((self realPosition x) @ (self realPosition y + self height))! !

!BoMovingMorph methodsFor: 'geometry' stamp: 'SO 1/30/2014 21:37:45.733'!
bottomLeft: aPoint

	super bottomLeft: aPoint.
	self position: ((aPoint x) @ (aPoint y - self height))! !

!BoMovingMorph methodsFor: 'geometry' stamp: 'SO 1/30/2014 21:37:57.321'!
bottomRight 

	^ ((self realPosition x + self width) @ (self realPosition y + self height))! !

!BoMovingMorph methodsFor: 'geometry' stamp: 'PL 1/11/2014 11:27:35.435'!
bottomRight: aPoint

	super bottomRight: aPoint.
	self position: ((aPoint x - self width) @ (aPoint y - self height))! !

!BoMovingMorph methodsFor: 'collision' stamp: 'mb 1/30/2014 15:07'!
calculateMoveLineSegmentAt: aPoint

	| lineSegment |
	
	lineSegment := BoLineSegment new.	
	lineSegment vector: self moveVector.
	lineSegment point: aPoint.
	
	^ lineSegment! !

!BoMovingMorph methodsFor: 'collision' stamp: 'PS 1/9/2014 23:28:24.675'!
calculateMoveLineSegments

	^ self subclassResponsibility! !

!BoMovingMorph methodsFor: 'collision' stamp: 'mb 1/22/2014 01:37'!
calculateNextCollision

	self nextCollisionDistance: Float fmax..
	self nextCollisionPoint: Float fmax @ Float fmax.
	
	self collidableMorphs do: [ :each |
		self checkForEarlierCollisionWith: each]! !

!BoMovingMorph methodsFor: 'geometry' stamp: 'PS 1/22/2014 18:58:23.182'!
center

	^ self topLeft + self bottomRight / 2! !

!BoMovingMorph methodsFor: 'collision' stamp: 'SO 1/30/2014 21:42:45.589'!
checkForEarlierCollisionWith: aMorph

	| lineSegments |
	
	lineSegments := self getLineSegmentsForCollisionWith: aMorph.	
	lineSegments do: [ :lineSegment | 
		self checkForEarlierCollisionWith: lineSegment of: aMorph ]! !

!BoMovingMorph methodsFor: 'collision' stamp: 'PL 1/31/2014 15:33:39.87'!
checkForEarlierCollisionWith: aLineSegment of: aMorph

	| distances |
	
	distances := aLineSegment first calculateFactorsToPointOfIntersectionWith:
					aLineSegment second.
	self maximizeOutOfRangeDistances: distances.
	(distances first < self nextCollisionDistance) ifTrue: [ 
		self nextCollisionDistance: distances first.
		self objectOfCollision: aMorph.
		self nextCollisionPoint: 
			(aLineSegment first point) + 
			(self nextCollisionDistance * (aLineSegment first vector)) ]! !

!BoMovingMorph methodsFor: 'collision' stamp: 'mb 1/30/2014 23:17'!
collidableMorphs
	
	| collidableMorphs |
	
	collidableMorphs := OrderedCollection new.
	self collidesWith do: [ :collidableMorph | 
		collidableMorphs addAll: (self collidableMorphsCatalog at: collidableMorph) value ].

	^ collidableMorphs! !

!BoMovingMorph methodsFor: 'collision' stamp: 'PS 1/15/2014 09:00:34.146'!
collidableMorphsCatalog

	^ IdentityDictionary newFrom: { 
		#block -> [ self game blocks ].
		#paddle -> [ { self game paddle } ].
		#game -> [ { self game } ].
		#ball -> [ self game balls ].
		#item -> [ self game items ] }! !

!BoMovingMorph methodsFor: 'collision' stamp: 'PL 1/11/2014 11:33:16.172'!
collidesWith

	^ self subclassResponsibility! !

!BoMovingMorph methodsFor: 'collision' stamp: 'mb 1/30/2014 23:17'!
createAllCombinationsOf: anOrderedCollection and: anotherOrderedCollection

	| result |
	
	result := OrderedCollection new.
	anOrderedCollection do: [ :each | 
		result addAll: (anotherOrderedCollection collect: [ :any | {each. any} ]) ].
	
	^ result! !

!BoMovingMorph methodsFor: 'collision' stamp: 'mb 1/30/2014 23:40'!
detectAndHandleCollision

	self 
		remainingStep: 1;
		isFirstChecking: true.
	[ self remainingStep strictlyPositive ] whileTrue: [
		self 
			moveLineSegments: self calculateMoveLineSegments;
			calculateNextCollision;
			moveRelativeBy: (self nextCollisionDistance min: self remainingStep);
			remainingStep: self remainingStep - self nextCollisionDistance.
		self remainingStep positive ifTrue: [ self handleCollision ].
		self isFirstChecking: false ]! !

!BoMovingMorph methodsFor: 'accessing' stamp: 'PS 1/9/2014 16:49:49.071'!
direction

	^ direction! !

!BoMovingMorph methodsFor: 'accessing' stamp: 'mb 1/30/2014 23:17'!
direction: aVector

	| length |	

	length := (aVector dotProduct: aVector) sqrt.
	length isZero
		ifTrue: [direction := aVector]
		ifFalse: [direction := aVector / length]! !

!BoMovingMorph methodsFor: 'accessing' stamp: 'PS 1/13/2014 12:37:53.33'!
game

	^ game! !

!BoMovingMorph methodsFor: 'accessing' stamp: 'PS 1/13/2014 12:37:53.385'!
game: anObject

	game := anObject! !

!BoMovingMorph methodsFor: 'collision' stamp: 'SO 1/30/2014 21:45:37.816'!
getLineSegmentsForCollisionWith: aCollidableMorph

	| morphLineSegments movingObjectLineSegments |
	
	movingObjectLineSegments := self moveLineSegments.
	morphLineSegments := aCollidableMorph calculateBorderLineSegmentsFor: 
								self direction.

	^ self createAllCombinationsOf: movingObjectLineSegments and: morphLineSegments! !

!BoMovingMorph methodsFor: 'collision' stamp: 'SO 1/30/2014 21:45:47.931'!
handleCollision

	self objectOfCollision handleCollisionWith: self at: (self nextCollisionPoint)! !

!BoMovingMorph methodsFor: 'initialization' stamp: 'mb 1/22/2014 13:25'!
initialize

	super initialize.
	self realPosition: super position.
	self moveLineSegments: OrderedCollection new! !

!BoMovingMorph methodsFor: 'classification' stamp: 'PS 1/11/2014 14:06:56.518'!
isBall

	^ false! !

!BoMovingMorph methodsFor: 'accessing' stamp: 'PS 1/13/2014 12:43:46.211'!
isFirstChecking

	^ isFirstChecking! !

!BoMovingMorph methodsFor: 'accessing' stamp: 'PS 1/13/2014 12:43:46.266'!
isFirstChecking: anObject

	isFirstChecking := anObject! !

!BoMovingMorph methodsFor: 'classification' stamp: 'PS 1/11/2014 14:06:49.405'!
isItem

	^ false! !

!BoMovingMorph methodsFor: 'geometry' stamp: 'PL 1/11/2014 10:20:03.698'!
left

	^ self realPosition x! !

!BoMovingMorph methodsFor: 'geometry' stamp: 'SO 1/30/2014 21:38:37.955'!
left: aNumber

	super left: aNumber.
	self position: (aNumber @ (self realPosition y))! !

!BoMovingMorph methodsFor: 'collision' stamp: 'PL 1/31/2014 15:43:38.733'!
maximizeOutOfRangeDistances: aDistancesCollection
	
	aDistancesCollection first negative ifTrue: [ aDistancesCollection at: 1 put: Float fmax ].
	(aDistancesCollection second between: 0 and: 1) ifFalse: [
		aDistancesCollection at: 1 put: Float fmax ].
	
	(self isFirstChecking not) &	(aDistancesCollection anySatisfy: [ :each | each closeTo: 0 ])
		ifTrue: [ aDistancesCollection at: 1 put: Float fmax ]! !

!BoMovingMorph methodsFor: 'movement' stamp: 'PS 1/11/2014 14:08:58.001'!
moveBy: aVector

	self position: self position + aVector! !

!BoMovingMorph methodsFor: 'accessing' stamp: 'mb 1/22/2014 13:48'!
moveLineSegments

	^ moveLineSegments! !

!BoMovingMorph methodsFor: 'accessing' stamp: 'mb 1/22/2014 13:22'!
moveLineSegments: anObject

	moveLineSegments := anObject! !

!BoMovingMorph methodsFor: 'movement' stamp: 'PS 1/14/2014 13:49:02.721'!
moveRelativeBy: aNumber

	self moveBy: self moveVector * aNumber! !

!BoMovingMorph methodsFor: 'accessing' stamp: 'PS 1/14/2014 13:48:28.839'!
moveVector 

	^ self speed * self direction ! !

!BoMovingMorph methodsFor: 'accessing' stamp: 'mb 1/22/2014 01:21'!
nextCollisionDistance

	^ nextCollisionDistance! !

!BoMovingMorph methodsFor: 'accessing' stamp: 'mb 1/22/2014 01:21'!
nextCollisionDistance: anObject

	nextCollisionDistance := anObject! !

!BoMovingMorph methodsFor: 'accessing' stamp: 'mb 1/22/2014 00:52'!
nextCollisionPoint

	^ nextCollisionPoint! !

!BoMovingMorph methodsFor: 'accessing' stamp: 'mb 1/22/2014 00:52'!
nextCollisionPoint: anObject

	nextCollisionPoint := anObject! !

!BoMovingMorph methodsFor: 'accessing' stamp: 'PS 1/13/2014 12:43:46.292'!
objectOfCollision

	^ objectOfCollision! !

!BoMovingMorph methodsFor: 'accessing' stamp: 'PS 1/13/2014 12:43:46.342'!
objectOfCollision: anObject

	objectOfCollision := anObject! !

!BoMovingMorph methodsFor: 'geometry' stamp: 'PL 1/11/2014 10:23:28.398'!
position

	^ self realPosition ! !

!BoMovingMorph methodsFor: 'geometry' stamp: 'PL 1/11/2014 10:23:00.281'!
position: aPoint

	super position: aPoint.
	self realPosition: aPoint! !

!BoMovingMorph methodsFor: 'accessing' stamp: 'PL 1/11/2014 10:12:25.85'!
realPosition

	^ realPosition! !

!BoMovingMorph methodsFor: 'accessing' stamp: 'PL 1/11/2014 10:12:25.883'!
realPosition: anObject

	realPosition := anObject! !

!BoMovingMorph methodsFor: 'accessing' stamp: 'PL 1/21/2014 21:58:36.057'!
remainingStep

	^ remainingStep! !

!BoMovingMorph methodsFor: 'accessing' stamp: 'PL 1/21/2014 21:58:36.094'!
remainingStep: anObject

	remainingStep := anObject! !

!BoMovingMorph methodsFor: 'geometry' stamp: 'PL 1/11/2014 10:32:15.037'!
right

	^ (self realPosition x + self width)! !

!BoMovingMorph methodsFor: 'geometry' stamp: 'PS 1/14/2014 13:55:02.663'!
right: aNumber

	super right: aNumber.
	self position: ((aNumber - self width) @ (self realPosition y))! !

!BoMovingMorph methodsFor: 'accessing' stamp: 'PS 1/9/2014 16:49:48.984'!
speed

	^ speed! !

!BoMovingMorph methodsFor: 'accessing' stamp: 'PS 1/9/2014 16:49:49.045'!
speed: anObject

	speed := anObject! !

!BoMovingMorph methodsFor: 'stepping and presenter' stamp: 'PS 1/13/2014 12:43:55.22'!
step
	
	self detectAndHandleCollision! !

!BoMovingMorph methodsFor: 'testing' stamp: 'PS 1/12/2014 12:05:32.772'!
stepTime

	^ 25! !

!BoMovingMorph methodsFor: 'geometry' stamp: 'PL 1/11/2014 10:25:25.671'!
top

	^ self realPosition y! !

!BoMovingMorph methodsFor: 'geometry' stamp: 'SO 1/30/2014 21:38:50.872'!
top: aNumber

	super top: aNumber.
	self position: ((self realPosition x) @ aNumber)! !

!BoMovingMorph methodsFor: 'geometry' stamp: 'PL 1/11/2014 10:26:29.452'!
topLeft

	^ self realPosition! !

!BoMovingMorph methodsFor: 'geometry' stamp: 'PL 1/11/2014 10:26:57.513'!
topLeft: aPoint

	super topLeft: aPoint.
	self position: aPoint! !

!BoMovingMorph methodsFor: 'geometry' stamp: 'SO 1/30/2014 21:39:00.214'!
topRight 

	^ ((self realPosition x + self width) @ (self realPosition y))! !

!BoMovingMorph methodsFor: 'geometry' stamp: 'PS 1/12/2014 16:24:47.178'!
topRight: aPoint

	super topRight: aPoint.
	self position: ((aPoint x - self width) @ (aPoint y))! !

BoMovingMorph subclass: #BoPaddle
	instanceVariableNames: 'balls leftKeyDown rightKeyDown hasBall isInverted'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BoBreakout'!

!BoPaddle commentStamp: 'PS 1/19/2014 15:41:32.831' prior: 0!
I am controlled by the player and can do an impact on the ball!

!BoPaddle class methodsFor: 'constants' stamp: 'PS 12/17/2013 12:09:28.983'!
distance

	^ 10! !

!BoPaddle class methodsFor: 'constants' stamp: 'SO 1/8/2014 13:59:05.09'!
inversionTimeout

	^ Time fromSeconds: 10! !

!BoPaddle class methodsFor: 'constants' stamp: 'SO 1/30/2014 21:54:31.488'!
leftKey

	(Smalltalk os platformName = 'Win32') ifTrue: [ ^ Character arrowLeft ].
	
	(Smalltalk os platformName = 'Mac OS') ifTrue: [ ^ ${ ]! !

!BoPaddle class methodsFor: 'constants' stamp: 'BM 12/11/2013 17:05'!
maxWidth

	^ 160! !

!BoPaddle class methodsFor: 'constants' stamp: 'BM 12/11/2013 17:43'!
minWidth

	^ 40! !

!BoPaddle class methodsFor: 'instance creation' stamp: 'PS 1/13/2014 12:40:27.09'!
newOn: aGame

	^ self new 
		game: aGame;
		startOver! !

!BoPaddle class methodsFor: 'constants' stamp: 'SO 1/30/2014 21:54:42.707'!
rightKey

	(Smalltalk os platformName = 'Win32') ifTrue: [ ^ Character arrowRight ].
	
	(Smalltalk os platformName = 'Mac OS') ifTrue: [ ^ $| ]! !

!BoPaddle class methodsFor: 'constants' stamp: 'BM 11/10/2013 20:18'!
scope

	^ 80 @ 20! !

!BoPaddle class methodsFor: 'constants' stamp: 'SO 1/30/2014 21:54:52.329'!
spaceKey

	(Smalltalk os platformName = 'Win32') ifTrue: [ ^ Character space ].
	
	(Smalltalk os platformName = 'Mac OS') ifTrue: [ ^ $1 ]! !

!BoPaddle class methodsFor: 'constants' stamp: 'PS 1/9/2014 11:23:25.416'!
speed

	^ 10! !

!BoPaddle class methodsFor: 'constants' stamp: 'PS 11/21/2013 15:10:11.802'!
yDistance

	^ 10! !

!BoPaddle methodsFor: 'accessing' stamp: 'PS 1/2/2014 12:52:10.855'!
balls

	^ balls! !

!BoPaddle methodsFor: 'accessing' stamp: 'PS 1/2/2014 12:52:10.908'!
balls: anObject

	balls := anObject! !

!BoPaddle methodsFor: 'accessing' stamp: 'tfel 5/9/2014 14:34'!
baseFileName

	^ 'paddle'! !

!BoPaddle methodsFor: 'collision' stamp: 'mb 1/30/2014 23:56'!
calculateMoveLineSegments

	| segmentContainer |
	
	segmentContainer := OrderedCollection new.
	
	(self direction x negative) ifTrue: [
		segmentContainer add: ( self calculateMoveLineSegmentAt: self topLeft ).
		segmentContainer add: ( self calculateMoveLineSegmentAt: self bottomLeft ) ] 
	ifFalse: [
		segmentContainer add: ( self calculateMoveLineSegmentAt: self topRight ).
		segmentContainer add: ( self calculateMoveLineSegmentAt: self bottomRight ) ].
	
	^ segmentContainer! !

!BoPaddle methodsFor: 'positioning' stamp: 'SO 1/30/2014 21:51:02.255'!
centerHorizontallyOn: aMorph

	self position: (aMorph center x - (self width / 2) ) @ 
					(aMorph bottom - (self height + self class yDistance))! !

!BoPaddle methodsFor: 'collision' stamp: 'SO 1/30/2014 21:50:36.627'!
collidesWith

	^ #(game ball)! !

!BoPaddle methodsFor: 'effects' stamp: 'SO 1/30/2014 21:51:21.589'!
extentHorizontallyBy: aNumber

	| oldWidth |
	
	oldWidth := self width.
	self increaseWidthBy: aNumber.
	self offsetExtensionBy: (self width - oldWidth)! !

!BoPaddle methodsFor: 'event handling' stamp: 'PS 11/11/2013 12:21:14.384'!
handlesKeyboard: anEvent

	^ true! !

!BoPaddle methodsFor: 'accessing' stamp: 'PS 11/25/2013 13:22:54.678'!
hasBall

	^ hasBall! !

!BoPaddle methodsFor: 'accessing' stamp: 'PS 11/25/2013 13:22:54.743'!
hasBall: anObject

	hasBall := anObject! !

!BoPaddle methodsFor: 'event handling' stamp: 'PS 11/11/2013 12:21:46.752'!
hasFocus 

	^ true! !

!BoPaddle methodsFor: 'effects' stamp: 'SO 1/30/2014 21:51:28.159'!
increaseWidthBy: aNumber

	| newWidth |
	
	newWidth := ((self width + aNumber) max: self class minWidth) min: self class maxWidth.
	self loadBackgroundWithName: (self baseFileName, newWidth)! !

!BoPaddle methodsFor: 'initialization' stamp: 'PL 1/31/2014 15:47:12.414'!
initialize 

	| imageName |	
	imageName := 'paddle80'.
	
	super initialize.
	self
		collisionHandler: BoPaddleCollisionHandler new;
		speed: self class speed;
		loadBackgroundWithName: imageName ! !

!BoPaddle methodsFor: 'collision' stamp: 'SO 1/30/2014 21:50:51.993'!
insideContainerWhenMovingBy: aVector

	| rectangle |
	
	rectangle := Rectangle
		origin: self bounds origin + aVector
		corner: self bounds corner + aVector.
		
	^ self game bounds containsRect: rectangle! !

!BoPaddle methodsFor: 'accessing' stamp: 'SO 1/8/2014 13:38:14.953'!
isInverted: anObject

	isInverted := anObject! !

!BoPaddle methodsFor: 'event handling' stamp: 'SO 1/4/2014 11:59'!
keyDown: anEvent
	
	(self paddleKeysDown at: anEvent keyCharacter ifAbsent: []) value! !

!BoPaddle methodsFor: 'event handling' stamp: 'PS 12/11/2013 11:40:33.393'!
keyUp: anEvent
	
	(self paddleKeysUp at: anEvent keyCharacter ifAbsent: []) value! !

!BoPaddle methodsFor: 'accessing' stamp: 'PS 12/11/2013 23:03:01.775'!
leftKeyDown

	^ leftKeyDown ifNil: [ leftKeyDown := false ]! !

!BoPaddle methodsFor: 'accessing' stamp: 'PS 12/11/2013 23:03:19.846'!
leftKeyDown: anObject

	leftKeyDown := anObject! !

!BoPaddle methodsFor: 'movement' stamp: 'PS 1/11/2014 14:10:00.639'!
moveBy: aVector
	
	super moveBy: aVector.
	self moveCapturedBallsBy: aVector! !

!BoPaddle methodsFor: 'movement' stamp: 'PL 1/8/2014 20:55:50.278'!
moveCapturedBallsBy: aVector

	self balls moveCapturedBallsBy: aVector! !

!BoPaddle methodsFor: 'movement' stamp: 'PS 12/12/2013 11:24:44.067'!
moveTo: aPoint

	self moveBy: aPoint - self position! !

!BoPaddle methodsFor: 'effects' stamp: 'SO 1/30/2014 21:51:44.244'!
offsetExtensionBy: aNumber

	| x delta |
	
	x := ((self left - (aNumber / 2)) max: 0) min: (self game right - self width).
	delta := (x - self left) @ 0.
	(self insideContainerWhenMovingBy: delta) ifTrue: [ 
		self position: self position + delta ]! !

!BoPaddle methodsFor: 'accessing' stamp: 'BM 1/16/2014 16:13'!
paddleKeysDown

	^ IdentityDictionary newFrom: {
		self class leftKey -> [ self leftKeyDown: true ].
		self class rightKey -> [ self rightKeyDown: true ] }! !

!BoPaddle methodsFor: 'accessing' stamp: 'PS 12/11/2013 23:04:35.393'!
paddleKeysUp

	^ IdentityDictionary newFrom: {
		self class leftKey -> [ self leftKeyDown: false  ].
		self class rightKey -> [ self rightKeyDown: false ].
		self class spaceKey -> [ self spaceAction ] }! !

!BoPaddle methodsFor: 'event handling' stamp: 'PS 12/11/2013 23:22:17.116'!
releaseBalls

	self balls releaseBalls.
	self hasBall: false! !

!BoPaddle methodsFor: 'effects' stamp: 'SO 1/19/2014 17:51:58.469'!
revertDirection

	self 
		isInverted: false;
		loadBackgroundWithName: (self baseFileName, self width)! !

!BoPaddle methodsFor: 'accessing' stamp: 'PS 12/11/2013 23:03:39.916'!
rightKeyDown

	^ rightKeyDown ifNil: [ rightKeyDown := false ]! !

!BoPaddle methodsFor: 'accessing' stamp: 'PS 12/11/2013 23:03:52.721'!
rightKeyDown: anObject

	rightKeyDown := anObject! !

!BoPaddle methodsFor: 'event handling' stamp: 'PS 1/9/2014 14:48:56.832'!
spaceAction

	self hasBall ifTrue: [ self releaseBalls ]! !

!BoPaddle methodsFor: 'initialization' stamp: 'SO 1/31/2014 20:31:32.815'!
startOver
	
	self rightKeyDown: false.
	self leftKeyDown: false.
	self centerHorizontallyOn: self game! !

!BoPaddle methodsFor: 'stepping and presenter' stamp: 'tfel 5/9/2014 14:37'!
step

	| leftDirection rightDirection |	
	self direction: 0@0.
	leftDirection := -1@0.
	rightDirection := 1@0.
	self leftKeyDown ifTrue: [ self direction: leftDirection ].
	self rightKeyDown ifTrue: [ self direction:  rightDirection ].
	super step.! !

!BoPaddle methodsFor: 'stepping and presenter' stamp: 'tfel 5/9/2014 14:38'!
step
	<layer: #invertedPaddle>
	| leftDirection rightDirection |	
	self direction: 0@0.
	leftDirection := -1@0.
	rightDirection := 1@0.
	self leftKeyDown ifTrue: [ self direction: rightDirection ].
	self rightKeyDown ifTrue: [ self direction:  leftDirection ].
	super step.! !

!BoPaddle methodsFor: 'testing' stamp: 'PS 12/17/2013 12:09:37.395'!
stepTime 

	^ 15! !

ImageMorph subclass: #BoScreen
	instanceVariableNames: 'parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BoBreakout'!

!BoScreen commentStamp: 'PL 1/30/2014 22:21:08.133' prior: 0!
I am a Screen.!

BoScreen subclass: #BoCreditsScreen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BoBreakout'!

!BoCreditsScreen commentStamp: 'PS 1/27/2014 20:29:21.099' prior: 0!
I show the Credits!

!BoCreditsScreen class methodsFor: 'constants' stamp: 'PS 1/28/2014 18:02:44.996'!
image

	^ #credits! !

!BoCreditsScreen methodsFor: 'initialization' stamp: 'PL 1/30/2014 22:33:47.461'!
initializeMenuButton
	
	| position |
	
	position := (self center x - (self class buttonExtent x / 2)) @ (self position y + 450).
	self addMorph: (SimpleButtonMorph new
		position: position;
		target: self parent;
		arguments: {#menu};
		actionSelector: #loadComponent:;
		label: 'Menu' font: Preferences windowTitleFont;
		extent: self class buttonExtent;
		color: Color lightGray;
		yourself)! !

!BoCreditsScreen methodsFor: 'initialization' stamp: 'PS 1/27/2014 19:03:31.322'!
setup

	self initializeMenuButton! !

BoScreen subclass: #BoGameOverScreen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BoBreakout'!

!BoGameOverScreen commentStamp: 'PS 1/27/2014 20:29:38.793' prior: 0!
I am shown when game is over!

!BoGameOverScreen class methodsFor: 'constants' stamp: 'PS 1/28/2014 18:14:09.196'!
image

	^ #gameOver! !

!BoGameOverScreen methodsFor: 'initialization' stamp: 'PL 1/30/2014 22:33:24.132'!
initializeMenuButton
	
	| position |
	
	position := (self center x - (self class buttonExtent x / 2)) @ (self position y + 450).
	self addMorph: (SimpleButtonMorph new
		position: position;
		target: self parent;
		arguments: {#menu};
		actionSelector: #loadComponent:;
		label: 'Menu' font: Preferences windowTitleFont;
		extent: self class buttonExtent;
		color: Color lightGray;
		yourself)! !

!BoGameOverScreen methodsFor: 'initialization' stamp: 'PS 1/28/2014 18:05:20.924'!
setup

	self initializeMenuButton! !

BoScreen subclass: #BoGameScreen
	instanceVariableNames: 'game'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BoBreakout'!

!BoGameScreen commentStamp: 'PS 1/27/2014 20:29:46.227' prior: 0!
I show the game!

!BoGameScreen class methodsFor: 'constants' stamp: 'BM 1/28/2014 12:20'!
sound

	^ #background! !

!BoGameScreen methodsFor: 'accessing' stamp: 'PS 1/27/2014 18:15:43.668'!
game

	^ game! !

!BoGameScreen methodsFor: 'accessing' stamp: 'PS 1/27/2014 18:15:43.702'!
game: anObject

	game := anObject! !

!BoGameScreen methodsFor: 'event handling' stamp: 'PS 1/27/2014 18:16:03.886'!
mouseFocusTarget 

	^ self game paddle! !

!BoGameScreen methodsFor: 'initialization' stamp: 'mb 1/30/2014 14:51'!
setup 

	self 
		game: (BoGame newOn: self parent);
		addMorph: self game! !

BoScreen subclass: #BoGameWonScreen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BoBreakout'!

!BoGameWonScreen commentStamp: 'PS 1/27/2014 20:29:54.114' prior: 0!
I am shown when game is won!

!BoGameWonScreen class methodsFor: 'constants' stamp: 'PS 1/28/2014 18:09:55.162'!
image

	^ #gameWon! !

!BoGameWonScreen methodsFor: 'initialization' stamp: 'PL 1/30/2014 22:33:01.241'!
initializeMenuButton
	
	| position |
	
	position := (self center x - (self class buttonExtent x / 2)) @ (self position y + 450).
	self addMorph: (SimpleButtonMorph new
		position: position;
		target: self parent;
		arguments: {#menu};
		actionSelector: #loadComponent:;
		label: 'Menu' font: Preferences windowTitleFont;
		extent: self class buttonExtent;
		color: Color lightGray;
		yourself)! !

!BoGameWonScreen methodsFor: 'initialization' stamp: 'PS 1/28/2014 18:05:31.533'!
setup

	self initializeMenuButton! !

BoScreen subclass: #BoMenuScreen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BoBreakout'!

!BoMenuScreen commentStamp: 'PS 1/19/2014 15:58:45.917' prior: 0!
I am the Menu of Breakout!

!BoMenuScreen class methodsFor: 'constants' stamp: 'PS 1/28/2014 18:03:34.292'!
image

	^ #splash! !

!BoMenuScreen methodsFor: 'initialization' stamp: 'PL 1/30/2014 22:31:39.948'!
initializeCreditsButton

	| position |
	
	position := (self center x - (self class buttonExtent x / 2)) @ (self position y + 450).
	self addMorph: (SimpleButtonMorph new
		position: position;
		target: self parent;
		arguments: {#credits};
		actionSelector: #loadComponent:;
		label: 'Credits' font: Preferences windowTitleFont;
		extent: self class buttonExtent;
		color: Color lightGray;
		yourself)! !

!BoMenuScreen methodsFor: 'initialization' stamp: 'PL 1/30/2014 22:31:50.527'!
initializeStartButton
	
	| position |
	
	position := (self center x - (self class buttonExtent x / 2)) @ (self position y + 375).
	self addMorph: (SimpleButtonMorph new
		position: position;
		target: self parent;
		arguments: {#game};
		actionSelector: #loadComponent:;
		label: 'Start' font: Preferences windowTitleFont;
		extent: self class buttonExtent;
		color: Color green;
		yourself)! !

!BoMenuScreen methodsFor: 'initialization' stamp: 'PS 1/27/2014 18:58:21.626'!
setup

	self 
		initializeStartButton;
		initializeCreditsButton! !

!BoScreen class methodsFor: 'constants' stamp: 'PS 1/27/2014 20:01:46.033'!
buttonExtent

	^ 150 @ 50! !

!BoScreen class methodsFor: 'constants' stamp: 'PS 1/28/2014 18:01:59.83'!
image

	^ #background! !

!BoScreen class methodsFor: 'instance creation' stamp: 'PS 1/27/2014 19:04:42.831'!
newOn: aMorph

	^ self new
		parent: aMorph;
		position: aMorph position;
		setup;
		yourself! !

!BoScreen class methodsFor: 'constants' stamp: 'BM 1/28/2014 14:47'!
sound

	^ #splashscreen! !

!BoScreen methodsFor: 'initialization' stamp: 'mb 1/30/2014 15:14'!
initialize 

	super initialize.
	self setNewImageFrom: 
		(BoTextureProvider instance textureWithSymbol: self class image)! !

!BoScreen methodsFor: 'event handling' stamp: 'PS 1/27/2014 18:16:16.836'!
mouseFocusTarget

	^ self! !

!BoScreen methodsFor: 'loading' stamp: 'mb 1/30/2014 15:13'!
onLoad

	BoSoundPlayer instance loopSound: self class sound! !

!BoScreen methodsFor: 'accessing' stamp: 'PS 1/27/2014 18:11:32.502'!
parent

	^ parent! !

!BoScreen methodsFor: 'accessing' stamp: 'PS 1/27/2014 18:11:32.572'!
parent: anObject

	parent := anObject! !

!BoScreen methodsFor: 'initialization' stamp: 'PS 1/28/2014 19:40:09.926'!
setup

	^ self subclassResponsibility ! !

Object subclass: #BoCollisionHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BoBreakout'!

!BoCollisionHandler commentStamp: 'PS 1/19/2014 15:41:42.611' prior: 0!
I handle a collision!

BoCollisionHandler subclass: #BoBallCollisionHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BoBreakout'!

!BoBallCollisionHandler commentStamp: 'PS 1/19/2014 15:42:46.272' prior: 0!
I handle the collision of a Ball!

!BoBallCollisionHandler methodsFor: 'collision' stamp: 'mb 1/30/2014 14:44'!
handleCollisionWith: aMovingMorph and: aCollidableMorph at: aPoint

	aCollidableMorph reflectBy: (-1 @ -1)! !

BoCollisionHandler subclass: #BoBubbleBlockCollisionHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BoBreakout'!

!BoBubbleBlockCollisionHandler commentStamp: 'PS 1/19/2014 15:43:05.748' prior: 0!
I handle the collision of a Block when its bubbly!

BoBubbleBlockCollisionHandler subclass: #BoBlockCollisionHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BoBreakout'!

!BoBlockCollisionHandler commentStamp: 'PS 1/19/2014 15:43:18.026' prior: 0!
I handle the collision of a Block!

!BoBlockCollisionHandler methodsFor: 'collision' stamp: 'PS 1/15/2014 22:29:41.104'!
applyDestroyEffectsOf: aCollidableMorph with: aMovingMorph
	
	aCollidableMorph handleItemDrop.
	super applyDestroyEffectsOf: aCollidableMorph with: aMovingMorph! !

!BoBlockCollisionHandler methodsFor: 'collision' stamp: 'PS 1/15/2014 22:30:21.68'!
handleCollisionWith: aMovingMorph and: aCollidableMorph at: aPoint

	self reflect: aMovingMorph from: aCollidableMorph at: aPoint.
	super handleCollisionWith: aMovingMorph and: aCollidableMorph at: aPoint! !

!BoBlockCollisionHandler methodsFor: 'testing' stamp: 'PS 1/19/2014 15:08:46.168'!
isBubbleBlock

	^ false! !

!BoBlockCollisionHandler methodsFor: 'collision' stamp: 'PL 1/31/2014 15:50:34.551'!
reflect: aMovingMorph from: aCollidableMorph at: aPoint

	| reflect horizontalReflection verticalReflection |	
	horizontalReflection := (1 @ -1).
	verticalReflection := (-1 @ 1).
	
	reflect := horizontalReflection.	
	((aCollidableMorph left closeTo: aPoint x) or: 
		[aCollidableMorph right closeTo: aPoint x]) ifTrue: [
			reflect := verticalReflection ].
	aMovingMorph reflectBy: reflect! !

!BoBubbleBlockCollisionHandler methodsFor: 'collision' stamp: 'mb 1/30/2014 15:13'!
applyCollisionEffectsOf: aCollidableMorph with: aMovingMorph

	(aCollidableMorph remainingLifes - aMovingMorph strength) strictlyPositive ifFalse: [ 
		self applyDestroyEffectsOf: aCollidableMorph with: aMovingMorph ].
	aCollidableMorph decreaseLifesBy: aMovingMorph strength.
	BoSoundPlayer instance playSound: #collision! !

!BoBubbleBlockCollisionHandler methodsFor: 'collision' stamp: 'PS 1/14/2014 15:18:10.133'!
applyDestroyEffectsOf: aCollidableMorph with: aMovingMorph
	
	aMovingMorph accelerateBy: aCollidableMorph destroySpeed! !

!BoBubbleBlockCollisionHandler methodsFor: 'collision' stamp: 'PS 1/14/2014 15:18:22.558'!
handleCollisionWith: aMovingMorph and: aCollidableMorph at: aPoint

	self applyCollisionEffectsOf: aCollidableMorph with: aMovingMorph! !

!BoBubbleBlockCollisionHandler methodsFor: 'testing' stamp: 'PS 1/19/2014 15:08:27.612'!
isBubbleBlock

	^ true! !

!BoCollisionHandler methodsFor: 'collision' stamp: 'PS 1/14/2014 15:18:31.102'!
handleCollisionWith: aMovingMorph and: aCollidableMorph at: aPoint

	^ self subclassResponsibility! !

BoCollisionHandler subclass: #BoGameCollisionHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BoBreakout'!

!BoGameCollisionHandler commentStamp: 'PS 1/19/2014 15:43:43.022' prior: 0!
I handle the collision with the gameField borders!

!BoGameCollisionHandler methodsFor: 'collision' stamp: 'mb 1/30/2014 15:13'!
handleCollisionWith: aMovingMorph and: aCollidableMorph at: aPoint

	aMovingMorph isBall 
		ifTrue: [ self reflect: aMovingMorph from: aCollidableMorph at: aPoint.
			BoSoundPlayer instance playSound: #collision ]
		ifFalse: [ aMovingMorph direction: (0 @ 0) ].
	
	(aPoint y >= aCollidableMorph bottom) ifTrue: [
		aMovingMorph remove ]! !

!BoGameCollisionHandler methodsFor: 'collision' stamp: 'PL 1/31/2014 15:50:49.674'!
reflect: aMovingMorph from: aCollidableMorph at: aPoint

	| reflect horizontalReflection verticalReflection |	
	horizontalReflection := (1 @ -1).
	verticalReflection := (-1 @ 1).
	
	reflect := verticalReflection.
	(aPoint y closeTo: aCollidableMorph top) ifTrue: [ 
		reflect := horizontalReflection ].
	
	aMovingMorph reflectBy: reflect! !

BoCollisionHandler subclass: #BoNullCollisionHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BoBreakout'!

!BoNullCollisionHandler commentStamp: 'PS 1/21/2014 23:45:13.766' prior: 0!
I handle actually don't do anything when an collision needs to be handled!

!BoNullCollisionHandler methodsFor: 'collision' stamp: 'PL 1/21/2014 17:54:44.357'!
handleCollisionWith: aMovingMorph and: aCollidableMorph at: aPoint! !

BoCollisionHandler subclass: #BoPaddleCollisionHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BoBreakout'!

!BoPaddleCollisionHandler commentStamp: 'PS 1/19/2014 15:57:54.921' prior: 0!
I handle collisions with the Paddle!

!BoPaddleCollisionHandler methodsFor: 'item applying' stamp: 'SO 1/31/2014 20:21:29.164'!
appyItem: anItem

	anItem 
		remove;
		applyEffect! !

!BoPaddleCollisionHandler methodsFor: 'collision' stamp: 'PS 1/14/2014 15:19:27.112'!
deflect: aMovingMorph from: aCollidableMorph at: aPoint

	| distance |	
	distance := (aPoint x - aCollidableMorph center x) / (aCollidableMorph width / 2).	
	aMovingMorph deflectBy: distance @ 0! !

!BoPaddleCollisionHandler methodsFor: 'collision' stamp: 'mb 1/30/2014 15:13'!
handleCollisionWith: aMovingMorph and: aCollidableMorph at: aPoint

	(aMovingMorph isBall) ifTrue: [
		self reflect: aMovingMorph from: aCollidableMorph at: aPoint.
		self deflect: aMovingMorph from: aCollidableMorph at: aPoint.
		BoSoundPlayer instance playSound: #collision ].
	(aMovingMorph isItem) ifTrue: [
		self appyItem: aMovingMorph ]! !

!BoPaddleCollisionHandler methodsFor: 'collision' stamp: 'PL 1/31/2014 15:51:16.081'!
reflect: aMovingMorph from: aCollidableMorph at: aPoint

	| reflect horizontalReflection verticalReflection |	
	horizontalReflection := (1 @ -1).
	verticalReflection := (-1 @ 1).
	
	reflect := horizontalReflection.	
	((aPoint x closeTo: aCollidableMorph left) or: 
		[aPoint x closeTo: aCollidableMorph right]) ifTrue: [ reflect := verticalReflection ].		
	aMovingMorph reflectBy: reflect! !

Object subclass: #BoLineSegment
	instanceVariableNames: 'point vector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BoBreakout'!

!BoLineSegment commentStamp: 'PS 1/19/2014 15:58:36.191' prior: 0!
I represent a lineSegment for a Point in a direction!

!BoLineSegment methodsFor: 'geometry' stamp: 'SO 1/30/2014 21:55:18.198'!
calculateDividendForIntersectionWith: aLineSegment
	
	^ ((self vector x * aLineSegment vector y) - (self vector y * aLineSegment vector x))! !

!BoLineSegment methodsFor: 'geometry' stamp: 'PL 1/4/2014 22:29:22.546'!
calculateFactorsToPointOfIntersectionWith: aLineSegment

	|aFactor anotherFactor|
	
	aFactor := self calculateOwnFactorToPointOfIntersectionWith: aLineSegment.
	anotherFactor := aLineSegment calculateOwnFactorToPointOfIntersectionWith: self.
		
	^ {aFactor. anotherFactor}! !

!BoLineSegment methodsFor: 'geometry' stamp: 'SO 1/30/2014 21:56:31.226'!
calculateOwnFactorToPointOfIntersectionWith: aLineSegment

	| aFactor dividend |
	
	aFactor := Float fmax.
	dividend := self calculateDividendForIntersectionWith: aLineSegment.
	dividend isZero ifFalse: [ 
		aFactor := (((aLineSegment point x - self point x) * aLineSegment vector y) - 
					((aLineSegment point y - self point y) * aLineSegment vector x)) 
					/ dividend ].		
						
	^ aFactor! !

!BoLineSegment methodsFor: 'accessing' stamp: 'PL 1/4/2014 22:14:35.643'!
point

	^ point! !

!BoLineSegment methodsFor: 'accessing' stamp: 'PL 1/4/2014 22:14:35.687'!
point: anObject

	point := anObject! !

!BoLineSegment methodsFor: 'accessing' stamp: 'PL 1/4/2014 22:14:35.718'!
vector

	^ vector! !

!BoLineSegment methodsFor: 'accessing' stamp: 'PL 1/4/2014 22:14:35.753'!
vector: anObject

	vector := anObject! !

Object subclass: #BoMorphGroup
	instanceVariableNames: 'game morphs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BoBreakout'!

!BoMorphGroup commentStamp: 'PS 1/19/2014 15:58:59.236' prior: 0!
I control acces to groups of Morphs!

BoMorphGroup subclass: #BoBallBasket
	instanceVariableNames: 'collisionHandler lifes paddle items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BoBreakout'!

!BoBallBasket commentStamp: 'PS 1/19/2014 15:59:21.91' prior: 0!
I represent the set of Balls!

!BoBallBasket methodsFor: 'adding' stamp: 'PL 1/31/2014 15:52:08.371'!
addBall
	
	| ball |
	
	ball := BoBall newOn: self game with: self.	
	ball
		collisionHandler: self collisionHandler;
		startOverAbove: self paddle.

	self add: ball! !

!BoBallBasket methodsFor: 'accessing' stamp: 'mb 1/30/2014 14:54'!
collisionHandler

	^ collisionHandler ifNil: [ collisionHandler := BoBallCollisionHandler new ]! !

!BoBallBasket methodsFor: 'accessing' stamp: 'mb 1/13/2014 21:42'!
collisionHandler: anObject

	collisionHandler := anObject! !

!BoBallBasket methodsFor: 'accessing' stamp: 'PS 1/27/2014 20:14:22.708'!
items

	^ items! !

!BoBallBasket methodsFor: 'accessing' stamp: 'PS 1/27/2014 20:14:22.734'!
items: anObject

	items := anObject! !

!BoBallBasket methodsFor: 'accessing' stamp: 'PS 1/27/2014 20:14:22.587'!
lifes

	^ lifes! !

!BoBallBasket methodsFor: 'accessing' stamp: 'PS 1/27/2014 20:14:22.634'!
lifes: anObject

	lifes := anObject! !

!BoBallBasket methodsFor: 'movement' stamp: 'mb 1/30/2014 23:22'!
moveCapturedBallsBy: aVector

	self do: [ :ball | ball isCaptured ifTrue: [ ball moveBy: aVector ] ]! !

!BoBallBasket methodsFor: 'accessing' stamp: 'PS 1/27/2014 20:14:22.658'!
paddle

	^ paddle! !

!BoBallBasket methodsFor: 'accessing' stamp: 'PS 1/27/2014 20:14:22.683'!
paddle: anObject

	paddle := anObject! !

!BoBallBasket methodsFor: 'movement' stamp: 'mb 1/30/2014 23:23'!
releaseBalls 

	self do: [ :ball | ball speed isZero ifTrue: [ ball releaseBall ] ]! !

!BoBallBasket methodsFor: 'removing' stamp: 'mb 1/30/2014 23:49'!
remove: aBall

	| noStepping |
	noStepping := -1.
	
	BoSoundPlayer instance playSound: #ballLost.
	aBall remainingStep: noStepping.
	super remove: aBall.
	self ifEmpty: [ 
		self addBall.
		self items removeAll.
		self lifes removeLife ]! !

!BoBallBasket methodsFor: 'removing' stamp: 'PS 1/9/2014 14:41:10.7'!
resetBalls
	
	self 
		removeAll;
		addBall! !

BoMorphGroup subclass: #BoBlockGroup
	instanceVariableNames: 'blockCollisionHandler bubbleBlockCollisionHandler items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BoBreakout'!

!BoBlockGroup commentStamp: 'PS 1/19/2014 15:59:35.387' prior: 0!
I represent the set of blocks and build them!

!BoBlockGroup class methodsFor: 'constants' stamp: 'SO 1/16/2014 23:09:14.456'!
block

	^ $+! !

!BoBlockGroup class methodsFor: 'instance creation' stamp: 'PS 1/27/2014 22:59:55.957'!
newWith: aGame

	^ self new
		game: aGame;
		yourself! !

!BoBlockGroup class methodsFor: 'constants' stamp: 'SO 1/16/2014 23:09:03.886'!
strongBlock

	^ $#! !

!BoBlockGroup methodsFor: 'adding' stamp: 'SO 1/30/2014 21:59:51.748'!
addBlockAt: aPoint as: aCharacter

	| block |
	
	block := (self blockTypes at: aCharacter) value.
	block position: aPoint.
	self add: block! !

!BoBlockGroup methodsFor: 'accessing' stamp: 'mb 1/13/2014 21:40'!
blockCollisionHandler

	^ blockCollisionHandler! !

!BoBlockGroup methodsFor: 'accessing' stamp: 'mb 1/13/2014 21:41'!
blockCollisionHandler: anObject

	blockCollisionHandler := anObject! !

!BoBlockGroup methodsFor: 'blocks' stamp: 'SO 1/30/2014 22:06:10.536'!
blockPrototype
	
	| block |
	
	block := BoBlock newOn: self with: self blockCollisionHandler and: self game items.
	block
		remainingLifes: 1;
		destroySpeed: 0.5;
		itemTypes: {
			#speedDownBalls.
			#speedUpBalls.
			#bubbleBlocks.
			#extraBall.
			#extraLife.
			#invertPaddleControl.
			#loseLife.
			#enlargePaddle.
			#shrinkPaddle.
			#strengthenBalls };
		itemDropProbability: 1 / 2.
		
	^ block! !

!BoBlockGroup methodsFor: 'blocks' stamp: 'PS 1/12/2014 18:06:43.88'!
blockTypes

	^ Dictionary newFrom: {
		self class block -> [ self blockPrototype ].
		self class strongBlock -> [ self strongBlockPrototype ] }! !

!BoBlockGroup methodsFor: 'accessing' stamp: 'mb 1/15/2014 12:01'!
bubbleBlockCollisionHandler

	^ bubbleBlockCollisionHandler! !

!BoBlockGroup methodsFor: 'accessing' stamp: 'mb 1/15/2014 12:01'!
bubbleBlockCollisionHandler: anObject

	bubbleBlockCollisionHandler := anObject! !

!BoBlockGroup methodsFor: 'initialization' stamp: 'mb 1/30/2014 14:57'!
initialize

	super initialize.
	self 
		blockCollisionHandler: BoBlockCollisionHandler new;
		bubbleBlockCollisionHandler: BoBubbleBlockCollisionHandler new! !

!BoBlockGroup methodsFor: 'adding' stamp: 'SO 1/16/2014 23:20:01.557'!
isValidBlockTypeCharacter: aCharacter

	^ self blockTypes includesKey: aCharacter! !

!BoBlockGroup methodsFor: 'accessing' stamp: 'PS 1/27/2014 20:14:02.148'!
items

	^ items! !

!BoBlockGroup methodsFor: 'accessing' stamp: 'PS 1/27/2014 20:14:02.199'!
items: anObject

	items := anObject! !

!BoBlockGroup methodsFor: 'removing' stamp: 'PS 1/13/2014 11:40:46.685'!
remove: aMorph

	super remove: aMorph.
	self ifEmpty: [ self game finishLevel ]! !

!BoBlockGroup methodsFor: 'effects' stamp: 'SO 1/30/2014 22:07:57.073'!
revertBubbleBlocks
	
	self 
		setCollisionHandlerForAll: self blockCollisionHandler;
		do: [ :block | block applyStyle ]! !

!BoBlockGroup methodsFor: 'effects' stamp: 'SO 1/30/2014 22:08:07.424'!
setCollisionHandlerForAll: aCollisionHandler

	self do: [ :block | block collisionHandler: aCollisionHandler ]! !

!BoBlockGroup methodsFor: 'blocks' stamp: 'SO 1/30/2014 22:06:48.991'!
strongBlockPrototype
	
	| strongBlock |
	
	strongBlock := BoBlock newOn: self with: self blockCollisionHandler and: self game items.
	strongBlock
		remainingLifes: 2;
		destroySpeed: 1;
		itemTypes: {
			#speedDownBalls.
			#speedUpBalls.
			#bubbleBlocks.
			#extraBall.
			#extraLife.
			#invertPaddleControl.
			#loseLife.
			#enlargePaddle.
			#shrinkPaddle.
			#strengthenBalls };
		itemDropProbability: 1 / 1.
		
	^ strongBlock! !

BoMorphGroup subclass: #BoItemDropper
	instanceVariableNames: 'timer nullCollisionHandler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BoBreakout'!

!BoItemDropper commentStamp: 'PS 1/19/2014 15:59:47.202' prior: 0!
I represent the set of item and drop them!

!BoItemDropper class methodsFor: 'constants' stamp: 'PS 1/21/2014 09:24:23.328'!
bubbleBlocks

	^ #bubbleBlocks! !

!BoItemDropper class methodsFor: 'constants' stamp: 'PS 1/21/2014 09:24:18.884'!
enlargePaddle

	^ #enlargePaddle! !

!BoItemDropper class methodsFor: 'constants' stamp: 'PS 1/21/2014 09:24:41.775'!
extraBall

	^ #extraBall! !

!BoItemDropper class methodsFor: 'constants' stamp: 'PS 1/21/2014 09:25:21.579'!
extraLife

	^ #extraLife! !

!BoItemDropper class methodsFor: 'constants' stamp: 'PS 1/21/2014 09:25:34.336'!
invertPaddleControl

	^ #invertPaddleControl! !

!BoItemDropper class methodsFor: 'constants' stamp: 'PS 1/21/2014 09:25:44.661'!
loseLife 

	^ #loseLife ! !

!BoItemDropper class methodsFor: 'instance creation' stamp: 'SO 1/30/2014 22:08:57.315'!
newWith: aGame
	
	| itemDropper |
	
	itemDropper := super newWith: aGame.
	itemDropper game addMorph: itemDropper timer.
	
	^ itemDropper! !

!BoItemDropper class methodsFor: 'constants' stamp: 'PS 1/19/2014 14:50:18.491'!
resizeValue

	^ 20! !

!BoItemDropper class methodsFor: 'constants' stamp: 'PS 1/21/2014 09:25:52.065'!
shrinkPaddle 

	^ #shrinkPaddle  ! !

!BoItemDropper class methodsFor: 'constants' stamp: 'PS 1/21/2014 09:25:59.844'!
speedDownBalls 

	^ #speedDownBalls ! !

!BoItemDropper class methodsFor: 'constants' stamp: 'PS 1/21/2014 09:26:06.609'!
speedUpBalls 

	^ #speedUpBalls ! !

!BoItemDropper class methodsFor: 'constants' stamp: 'PS 1/21/2014 09:26:21.757'!
strengthenBalls 

	^ #strengthenBalls ! !

!BoItemDropper methodsFor: 'items' stamp: 'tfel 5/9/2014 14:41'!
bubbleBlocks

	| imageName |
	imageName := 'bubbleBlocks'.

	^ BoItem newOn: self game with: self and: imageName 
		perform: [ 
			#bubbleBlocks activateLayerInCurrentProcess.
			self timer addTask: #bubbleBlocks execute: 
				[#bubbleBlocks deactivateLayerInCurrentProcess] in: 3500 ]! !

!BoItemDropper methodsFor: 'item dropping' stamp: 'mb 1/30/2014 23:42'!
dropItem: aSymbol at: aPoint

	| item |
	
	item := ((self itemTypes at: aSymbol) value)
				position: aPoint;
				collisionHandler: self nullCollisionHandler;
				yourself.
				
	self add: item! !

!BoItemDropper methodsFor: 'items' stamp: 'mb 1/30/2014 23:48'!
enlargePaddle

	| imageName |
	imageName := 'enlargePaddle'.

	^ BoItem newOn: self game with: self and: imageName
		perform: [ 
			self game paddle extentHorizontallyBy: self class resizeValue ]! !

!BoItemDropper methodsFor: 'items' stamp: 'mb 1/30/2014 23:48'!
extraBall

	| imageName |
	imageName := 'extraBall'.

	^ BoItem newOn: self game with: self and: imageName
		perform: [ 
			(self game balls) 
				addBall;
				releaseBalls ]! !

!BoItemDropper methodsFor: 'items' stamp: 'mb 1/30/2014 23:48'!
extraLife

	| imageName |
	imageName := 'extraLife'.

	^ BoItem newOn: self game with: self and: imageName
		perform: [ 
			self game lifes addLife ]! !

!BoItemDropper methodsFor: 'initialization' stamp: 'mb 1/30/2014 15:14'!
initialize

	super initialize.
	self 
		timer: BoTimer new;
		nullCollisionHandler: BoNullCollisionHandler new! !

!BoItemDropper methodsFor: 'items' stamp: 'tfel 5/9/2014 14:38'!
invertPaddleControl

	| imageName timeout |
	imageName := 'invertPaddle'.
	timeout := 8000.

	^ BoItem newOn: self game with: self and: imageName
		perform: [ 
			#invertedPaddle activateLayerInCurrentProcess.
			self timer addTask: #invertDirection execute:
				[#invertedPaddle deactivateLayerInCurrentProcess] in: timeout ]! !

!BoItemDropper methodsFor: 'items' stamp: 'PS 1/21/2014 09:27:55.515'!
itemTypes

	^ Dictionary newFrom: {
		self class bubbleBlocks -> [ self bubbleBlocks ].
		self class enlargePaddle -> [ self enlargePaddle ].
		self class extraLife -> [ self extraLife ].
		self class extraBall -> [ self extraBall ].
		self class invertPaddleControl -> [ self invertPaddleControl ].
		self class loseLife -> [ self loseLife ].
		self class shrinkPaddle -> [ self shrinkPaddle ].
		self class speedUpBalls -> [ self speedUpBalls ].
		self class speedDownBalls -> [ self speedDownBalls ].
		self class strengthenBalls -> [ self strengthenBalls ] }
		! !

!BoItemDropper methodsFor: 'items' stamp: 'mb 1/30/2014 23:47'!
loseLife

	| imageName |
	imageName := 'loseLife'.

	^ BoItem newOn: self game with: self and: imageName
		perform: [ 
			self game lifes removeLife ]! !

!BoItemDropper methodsFor: 'accessing' stamp: 'PL 1/21/2014 17:56:34.534'!
nullCollisionHandler

	^ nullCollisionHandler! !

!BoItemDropper methodsFor: 'accessing' stamp: 'PL 1/21/2014 17:56:34.576'!
nullCollisionHandler: anObject

	nullCollisionHandler := anObject! !

!BoItemDropper methodsFor: 'removing' stamp: 'PS 1/21/2014 09:18:39.674'!
removeAll

	super removeAll.
	self timer triggerAll! !

!BoItemDropper methodsFor: 'items' stamp: 'mb 1/30/2014 23:47'!
shrinkPaddle

	| imageName |
	imageName := 'shrinkPaddle'.

	^ BoItem newOn: self game with: self and: imageName
		perform: [ 
			self game paddle extentHorizontallyBy: self class resizeValue negated ]! !

!BoItemDropper methodsFor: 'items' stamp: 'tfel 5/9/2014 14:32'!
speedDownBalls

	| imageName |
	imageName := 'speedDown'.

	^ BoItem newOn: self game with: self and: imageName
		perform: [#speedyBalls deactivateLayerInCurrentProcess]! !

!BoItemDropper methodsFor: 'items' stamp: 'tfel 5/9/2014 14:32'!
speedUpBalls

	| imageName |	
	imageName := 'speedUp'.

	^ BoItem newOn: self game with: self and: imageName
		perform: [#speedyBalls activateLayerInCurrentProcess]! !

!BoItemDropper methodsFor: 'items' stamp: 'tfel 5/9/2014 14:33'!
strengthenBalls

	| imageName |
	imageName := 'strengthenBall'.

	^ BoItem newOn: self game with: self and: imageName
		perform: [#strongBalls activateLayerInCurrentProcess]! !

!BoItemDropper methodsFor: 'accessing' stamp: 'PS 1/21/2014 08:49:39.663'!
timer

	^ timer! !

!BoItemDropper methodsFor: 'accessing' stamp: 'PS 1/21/2014 08:49:39.733'!
timer: anObject

	timer := anObject! !

BoMorphGroup subclass: #BoLifeBar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BoBreakout'!

!BoLifeBar commentStamp: 'PS 1/21/2014 23:45:36.301' prior: 0!
I represent the lifes of the player!

!BoLifeBar class methodsFor: 'constants' stamp: 'PS 1/21/2014 09:45:27.74'!
lifeSpacing

	^ 2! !

!BoLifeBar class methodsFor: 'constants' stamp: 'PS 1/21/2014 09:45:42.589'!
maxLifes

	^ 6! !

!BoLifeBar class methodsFor: 'constants' stamp: 'PS 1/28/2014 19:31:50.292'!
startLifes 

	^ 5! !

!BoLifeBar methodsFor: 'adding' stamp: 'SO 1/30/2014 22:19:32.901'!
add: aMorph

	(self size < self class maxLifes) ifTrue: [ super add: aMorph ]! !

!BoLifeBar methodsFor: 'adding' stamp: 'SO 1/30/2014 22:21:16.325'!
addLife

	| life positionY positionX |
	
	life := self createLife.
	positionY := self game top + self class lifeSpacing.
	positionX := self game right - ((self size + 1) * (self class lifeSpacing + life width)).
	life position: positionX@positionY.
	self add: life! !

!BoLifeBar methodsFor: 'submorphs-add/remove' stamp: 'PS 1/28/2014 19:53:19.76'!
bringAllToFront

	 self do: [ :life | life comeToFront ]! !

!BoLifeBar methodsFor: 'adding' stamp: 'SO 1/30/2014 22:21:25.642'!
createLife

	| life |
	
	life := ImageMorph new.
	life setNewImageFrom: (BoTextureProvider instance textureWithSymbol: #heart).
						
	^ life! !

!BoLifeBar methodsFor: 'removing' stamp: 'mb 1/30/2014 15:13'!
remove: aMorph

	BoSoundPlayer instance playSound: #lifeLost.
	super remove: aMorph.
	self ifEmpty: [ self game gameOver ]! !

!BoLifeBar methodsFor: 'removing' stamp: 'PS 1/21/2014 10:05:34.147'!
removeLife

	self remove: self last! !

!BoLifeBar methodsFor: 'removing' stamp: 'PS 1/28/2014 19:33:32.991'!
resetLifes

	self removeAll.
	self class startLifes timesRepeat: [ self addLife ]	! !

!BoMorphGroup class methodsFor: 'instance creation' stamp: 'PS 1/27/2014 23:02:15.121'!
newWith: aGame
	
	^ self new
		game: aGame;
		yourself! !

!BoMorphGroup methodsFor: 'adding' stamp: 'PS 1/15/2014 22:21:44.561'!
add: aMorph

	self morphs add: aMorph.
	self game addMorph: aMorph! !

!BoMorphGroup methodsFor: 'adding' stamp: 'PS 1/15/2014 22:21:48.782'!
do: aBlock

	self morphs do: aBlock! !

!BoMorphGroup methodsFor: 'accessing' stamp: 'PS 1/7/2014 09:23:34.752'!
game

	^ game! !

!BoMorphGroup methodsFor: 'accessing' stamp: 'PS 1/7/2014 09:23:34.812'!
game: anObject

	game := anObject! !

!BoMorphGroup methodsFor: 'testing' stamp: 'PS 1/15/2014 22:21:51.418'!
ifEmpty: aBlock

	self morphs ifEmpty: aBlock! !

!BoMorphGroup methodsFor: 'initialization' stamp: 'PS 1/15/2014 22:21:27.104'!
initialize

	super initialize.
	self morphs: OrderedCollection new! !

!BoMorphGroup methodsFor: 'accessing' stamp: 'PS 1/21/2014 10:05:17.739'!
last

	^ self morphs last! !

!BoMorphGroup methodsFor: 'accessing' stamp: 'PS 1/15/2014 22:21:12.958'!
morphs

	^ morphs! !

!BoMorphGroup methodsFor: 'accessing' stamp: 'PS 1/15/2014 22:21:13.002'!
morphs: anObject

	morphs := anObject! !

!BoMorphGroup methodsFor: 'removing' stamp: 'PL 1/21/2014 21:50:16.313'!
remove: aMorph

	self game removeMorph: aMorph.
	self morphs remove: aMorph! !

!BoMorphGroup methodsFor: 'removing' stamp: 'SO 1/30/2014 21:57:56.334'!
removeAll

	self do: [ :morph | self game removeMorph: morph ].
	self morphs removeAll! !

!BoMorphGroup methodsFor: 'accessing' stamp: 'PS 1/21/2014 09:46:59.284'!
size

	^ self morphs size! !

Object subclass: #BoSoundPlayer
	instanceVariableNames: 'sounds loopedSound loopedSymbol'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BoBreakout'!

BoSoundPlayer class
	instanceVariableNames: 'instance'!

!BoSoundPlayer commentStamp: 'PS 1/19/2014 16:00:01.302' prior: 0!
I play sounds for Breakout!

BoSoundPlayer class
	instanceVariableNames: 'instance'!

!BoSoundPlayer class methodsFor: 'accessing' stamp: 'PL 1/30/2014 22:13:21.608'!
instance

	^ instance ifNil: [ self instance: self new ]! !

!BoSoundPlayer class methodsFor: 'accessing' stamp: 'BM 1/7/2014 14:41'!
instance: anObject

	instance := anObject! !

!BoSoundPlayer class methodsFor: 'instance creation' stamp: 'PS 1/11/2014 16:56:25.036'!
recreateInstance

	self instance: self new! !

!BoSoundPlayer methodsFor: 'initialization' stamp: 'PS 1/28/2014 19:46:54.235'!
initialize

	super initialize.
	self sounds: IdentityDictionary new.
	SoundPlayer stopReverb! !

!BoSoundPlayer methodsFor: 'loading' stamp: 'PL 1/31/2014 15:27:36.244'!
loadSound: aSoundName

	| fileName sound defaultURI soundExtension |
	defaultURI := 'BoBreakout/sounds/'.
	soundExtension := '.wav'.
	
	fileName := (FileDirectory uri: defaultURI, aSoundName, soundExtension) fullName.
	sound := SampledSound fromWaveFileNamed: fileName.
	self sounds at: aSoundName asSymbol put: sound.
	
	^ sound! !

!BoSoundPlayer methodsFor: 'playing' stamp: 'mb 1/30/2014 23:41'!
loopSound: aSymbol

	| aSound |
	
	 self loopedSymbol = aSymbol ifFalse: [
		self loopedSymbol: aSymbol.
		aSound := self sounds at: aSymbol ifAbsent: [ self loadSound: aSymbol asString ].
		self loopedSound
			setSound: aSound iterations: #forever;
			play ]! !

!BoSoundPlayer methodsFor: 'accessing' stamp: 'BM 1/28/2014 15:08'!
loopedSound

	^ loopedSound ifNil: [ loopedSound := RepeatingSound new ]! !

!BoSoundPlayer methodsFor: 'accessing' stamp: 'BM 1/28/2014 11:41'!
loopedSound: anObject

	loopedSound := anObject! !

!BoSoundPlayer methodsFor: 'accessing' stamp: 'BM 1/28/2014 18:18'!
loopedSymbol

	^ loopedSymbol! !

!BoSoundPlayer methodsFor: 'accessing' stamp: 'BM 1/28/2014 18:18'!
loopedSymbol: anObject

	loopedSymbol := anObject! !

!BoSoundPlayer methodsFor: 'playing' stamp: 'PS 1/14/2014 15:20:17.47'!
playSound: aSymbol
	
	(self sounds at: aSymbol ifAbsent: [ self loadSound: aSymbol asString ]) play! !

!BoSoundPlayer methodsFor: 'accessing' stamp: 'BM 1/7/2014 15:17'!
sounds

	^ sounds! !

!BoSoundPlayer methodsFor: 'accessing' stamp: 'BM 1/7/2014 15:17'!
sounds: anObject

	sounds := anObject! !

!BoSoundPlayer methodsFor: 'playing' stamp: 'BM 1/28/2014 14:40'!
stopLoop

	self loopedSound pause! !

Object subclass: #BoTask
	instanceVariableNames: 'triggerTime action'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BoBreakout'!

!BoTask commentStamp: 'PS 1/19/2014 16:00:24.611' prior: 0!
I am a task that will be triggered after some time!

!BoTask class methodsFor: 'instance creation' stamp: 'PS 1/27/2014 23:06:43.678'!
newAt: aNumber execute: aBlock

	^ self new 
		triggerTime: aNumber;
		action: aBlock;
		yourself
! !

!BoTask methodsFor: 'accessing' stamp: 'BM 1/16/2014 14:43'!
action

	^ action! !

!BoTask methodsFor: 'accessing' stamp: 'BM 1/16/2014 14:43'!
action: anObject

	action := anObject! !

!BoTask methodsFor: 'triggering' stamp: 'PL 1/30/2014 22:10:47.712'!
isTriggered

	| trigger |
	
	trigger := false.
	(self triggerTime <= Time milliSecondsSinceMidnight) ifTrue: [ trigger := true ].
	trigger ifTrue: [ self trigger ].
	^ trigger! !

!BoTask methodsFor: 'triggering' stamp: 'BM 1/19/2014 15:21'!
trigger

	self action value! !

!BoTask methodsFor: 'accessing' stamp: 'BM 1/16/2014 14:43'!
triggerTime

	^ triggerTime! !

!BoTask methodsFor: 'accessing' stamp: 'BM 1/16/2014 14:43'!
triggerTime: anObject

	triggerTime := anObject! !

Object subclass: #BoTextureProvider
	instanceVariableNames: 'textures'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BoBreakout'!

BoTextureProvider class
	instanceVariableNames: 'instance'!

!BoTextureProvider commentStamp: 'PS 1/19/2014 16:00:36.324' prior: 0!
I provide textures for Breakout!

BoTextureProvider class
	instanceVariableNames: 'instance'!

!BoTextureProvider class methodsFor: 'accessing' stamp: 'PS 1/19/2014 14:53:43.769'!
instance

	^ instance ifNil: [ self instance: self new ]! !

!BoTextureProvider class methodsFor: 'accessing' stamp: 'PS 1/11/2014 16:06:06.703'!
instance: anObject

	instance := anObject! !

!BoTextureProvider class methodsFor: 'instance creation' stamp: 'PS 1/11/2014 16:55:49.491'!
recreateInstance

	self instance: self new! !

!BoTextureProvider methodsFor: 'initialization' stamp: 'PS 1/11/2014 17:15:56.292'!
initialize

	super initialize.
	self textures: IdentityDictionary new! !

!BoTextureProvider methodsFor: 'loading' stamp: 'PL 1/31/2014 15:27:05.187'!
loadTexture: aTextureName

	| texture defaultURI textureExtension |
	defaultURI := 'BoBreakout/figures/'.
	textureExtension := '.png'.
	
	texture := ImageReadWriter formFromFileNamed: 
		(FileDirectory uri: defaultURI, aTextureName, textureExtension ) fullName.
	self textures at: aTextureName asSymbol put: texture.
	
	^ texture! !

!BoTextureProvider methodsFor: 'textures' stamp: 'PS 1/11/2014 17:16:39.273'!
textureWithSymbol: aSymbol

	^ self textures at: aSymbol ifAbsent: [ self loadTexture: aSymbol asString ]! !

!BoTextureProvider methodsFor: 'accessing' stamp: 'PS 1/11/2014 16:05:38.105'!
textures

	^ textures! !

!BoTextureProvider methodsFor: 'accessing' stamp: 'PS 1/11/2014 16:05:38.137'!
textures: anObject

	textures := anObject! !

Morph subclass: #BoTimer
	instanceVariableNames: 'tasks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BoBreakout'!

!BoTimer commentStamp: 'PS 1/19/2014 16:00:51.74' prior: 0!
I trigger tasks when their time has come!

!BoTimer methodsFor: 'accessing' stamp: 'PL 1/30/2014 22:11:55.969'!
addTask: aSymbol execute: aBlock in: aNumber

	| triggerTime task |
	
	triggerTime := Time milliSecondsSinceMidnight + aNumber.
	task := BoTask newAt: triggerTime execute: aBlock.
	self tasks at: aSymbol put: task! !

!BoTimer methodsFor: 'initialization' stamp: 'BM 1/19/2014 15:00'!
initialize

	super initialize.
	self tasks: IdentityDictionary new;
		visible: false! !

!BoTimer methodsFor: 'stepping and presenter' stamp: 'BM 1/16/2014 15:33'!
step
	
	self tasks keysAndValuesRemove: [ :key :task | task isTriggered ]! !

!BoTimer methodsFor: 'testing' stamp: 'BM 1/16/2014 15:23'!
stepTime

	^ 20! !

!BoTimer methodsFor: 'accessing' stamp: 'BM 1/19/2014 15:00'!
tasks

	^ tasks! !

!BoTimer methodsFor: 'accessing' stamp: 'BM 1/16/2014 14:30'!
tasks: anObject

	tasks := anObject! !

!BoTimer methodsFor: 'stepping and presenter' stamp: 'BM 1/19/2014 15:22'!
triggerAll

	self tasks valuesDo: [ :task | task trigger ];
		removeAll! !
